/*
<:copyright-broadcom 
 
 Copyright (c) 2002 Broadcom Corporation 
 All Rights Reserved 
 No portions of this material may be reproduced in any form without the 
 written permission of: 
          Broadcom Corporation 
          16215 Alton Parkway 
          Irvine, California 92619 
 All information contained in this document is Broadcom Corporation 
 company private, proprietary, and trade secret. 
 
:>
*/
/****************************************************************************
 *
 * BcmAdslDiag.h -- Internal definitions for ADSL diagnostic
 *
 * Description:
 *	Internal definitions for ADSL core driver
 *
 *
 * Authors: Ilya Stomakhin
 *
 * $Revision: 1.1 $
 *
 * $Id: BcmAdslDiag.h,v 1.1 2004/04/08 21:24:49 ilyas Exp $
 *
 * $Log: BcmAdslDiag.h,v $
 * Revision 1.1  2004/04/08 21:24:49  ilyas
 * Initial CVS checkin. Version A2p014
 *
 ****************************************************************************/

#define			DIAG_SPLIT_MSG		0x80000000
#define			DIAG_MSG_NUM		0x40000000

int	 BcmAdslDiagTaskInit(void);
void BcmAdslDiagTaskUninit(void);
int  BcmAdslDiagInit(int diagDataMap);
void BcmAdslCoreDiagDmaInit(void);
void * BcmAdslCoreDiagGetDmaDataAddr(int descNum);
int	 BcmAdslCoreDiagGetDmaDataSize(int descNum);
int	 BcmAdslCoreDiagGetDmaBlockNum(void);
void BcmAdslDiagReset(int diagDataMap);
void BcmAdslCoreDiagWriteStatusData(ulong cmd, char *buf0, int len0, char *buf1, int len1);
void BcmAdslCoreDiagStatusSnooper(dslStatusStruct *status, char *pBuf, int len);
void BcmAdslCoreDiagWriteStatusString(char *fmt, ...);
int  BcmAdslCoreDiagWrite(void *pBuf, int len);
void BcmAdslCoreDiagWriteLog(long logData, ...);
Bool BcmAdslCoreDiagIntrHandler(void);
void BcmAdslCoreDiagIsrTask(void);
void BcmAdslCoreLogWriteConnectionParam(dslCommandStruct *pDslCmd);
int  BcmAdslDiagGetConstellationPoints (int toneId, void *pointBuf, int numPoints);
int	 BcmAdslDiagDisable(void);
int	 BcmAdslDiagEnable(void);
Bool BcmAdslDiagIsActive(void);
void BcmAdslCoreDiagStartLog(unsigned long map, unsigned long time);
void BcmAdslCoreWriteOvhMsg(void *gDslVars, char *hdr, dslFrame *pFrame);